@using Entities
@using Business
@using DataAccess


@inject IDbContextFactory<inventory_context> ContextFactory
@inject NavigationManager navManager

@if (DataLoading)
{
    <h5>@loading_message</h5>
}


<div>
    <EditForm Model="oCategory">
        <DataAnnotationsValidator />
        <div class="form-group">
            <label for="">Codigo de Categoria:</label>
            <InputText @bind-Value="oCategory.CatCode" class="form-control"/>
            <ValidationMessage For="@(() => oCategory.CatCode)" class="text-danger"/>
        </div>
        <br>

        <div class="form-group">
            <label for="">Nombre de Categoria:</label>
            <InputText @bind-Value="oCategory.CatName" class="form-control"/>
            <ValidationMessage For="@(() => oCategory.CatName)" class="text-danger"/>
        </div>
        <br>

        <input type="button" value="Agregar Categoria" @onclick="SaveCategory">

    </EditForm>
</div>


@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching Categories ...";

    Category oCategory = new();

    B_Category bCategory = null!;

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading)
        {
            return;
        }


        try
        {
            DataLoading = true;
            bCategory = new (ContextFactory);
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
        await base.OnInitializedAsync();
    }

    private async Task SaveCategory()
    {
        if (bCategory is not null)
        {
            await bCategory.CreateCategory(oCategory);
            navManager.NavigateTo("category/list");
        }
    }

    private void HandleValidSubmit()
    {
        Console.WriteLine($"OnValidSubmit");
        
    }


}